[LeetCode] 27.移除元素
1. 问题描述
27. 移除元素
给你一个数组 nums **和一个值 val,你需要 原地 移除所有数值等于 val **的元素。元素的顺序可能发生改变。然后返回 nums 中与 val 不同的元素的数量。
假设 nums 中不等于 val 的元素数量为 k,要通过此题,您需要执行以下操作:
- 更改
nums数组,使nums的前k个元素包含不等于val的元素。nums的其余元素和nums的大小并不重要。 - 返回
k。
用户评测:
评测机将使用以下代码测试您的解决方案:
int[] nums = [...]; // 输入数组
int val = ...; // 要移除的值
int[] expectedNums = [...]; // 长度正确的预期答案。
// 它以不等于 val 的值排序。
int k = removeElement(nums, val); // 调用你的实现
assert k == expectedNums.length;
sort(nums, 0, k); // 排序 nums 的前 k 个元素
for (int i = 0; i < k; i++) {
assert nums[i] == expectedNums[i];
}
如果所有的断言都通过,你的解决方案将会 通过。
示例 1:
输入:nums = [3,2,2,3], val = 3
输出:2, nums = [2,2,_,_]
解释:你的函数应该返回 k = 2, 并且 nums中的前两个元素均为 2。
你在返回的 k 个元素之外留下了什么并不重要(因此它们并不计入评测)。
示例 2:
输入:nums = [0,1,2,2,3,0,4,2], val = 2
输出:5, nums = [0,1,4,0,3,_,_,_]
解释:你的函数应该返回 k = 5,并且 nums 中的前五个元素为 0,0,1,3,4。
注意这五个元素可以任意顺序返回。
你在返回的 k 个元素之外留下了什么并不重要(因此它们并不计入评测)。
提示:
0 <= nums.length <= 1000 <= nums[i] <= 500 <= val <= 100
2. 实现思路
2.1 自己的思路
无论实现与否,都是群星的一丝痕迹~~(唔,所以一定要写出来啊喂)~
虽然改了很多次test,但最后一次submit就过惹,还是很开心的(虽然依旧暴力解法
时间复杂度O(n^2),空间复杂度O(1)
public class Solution
{
public int RemoveElement(int[] nums, int val)
{
int deleted = 0;
for (int i = 0; i < nums.Length - deleted; i++)
{
if (nums[i] == val)
{
for (int j = i; j < nums.Length - 1; j++)
{
nums[j] = nums[j + 1];
}
deleted++;
i--;
}
}
return nums.Length - deleted;
}
}
基本思路是这样的:题目是原地删除元素,那么最常见的删除方式是将当前需要删除位置后的所有数组元素前移一位就行(因为当前需要删除的是脏位置,可以直接不管);然后再用deleted记录一下删除了多少,最后返回的数组长度减去deleted就是k了。
踩的坑:
- deleted++写到里层的for去了,里层for是用来前移元素的,应该在for外自增
- 末尾的i—,在移除元素后,也需要对当前i处(原来的待移除元素后一位元素)进行判断
- 外层for的循环边界条件,一定要减去deleted,因为已删除的元素不需要再进行校验是否为val,防止越界
2.2 题解思路
- 方法一:双指针(快慢指针)
时间复杂度O(n):至多遍历该序列两次(right读一次,left写一次)
空间复杂度O(1)
public class Solution
{
public int RemoveElement(int[] nums, int val)
{
int left = 0;
for (int right = 0; right < nums.Length; right++)
{
if (nums[right] != val)
{
nums[left] = nums[right];
left++;
}
}
return left;
}
}
由于题目要求删除数组中等于 val 的元素,因此输出数组的长度一定小于等于输入数组的长度,我们可以把输出的数组直接写在输入数组上。可以使用双指针:右指针 right 指向当前将要处理的元素,左指针 left 指向下一个将要复制的位置。
如果右指针指向的元素不等于 val,它一定是输出数组的一个元素,我们就将右指针指向的元素复制到左指针位置,然后将左右指针同时右移;
如果右指针指向的元素等于 val,它不能在输出数组里,此时左指针不动,右指针右移一位。
整个过程保持不变的性质是:区间 [0,left) 中的元素都不等于 val。当左右指针遍历完输入数组以后,left 的值就是输出数组的长度。
这样的算法在最坏情况下(输入数组中没有元素等于 val),左右指针各遍历了数组一次。
作者:力扣官方题解
链接:https://leetcode.cn/problems/remove-element/solutions/730203/yi-chu-yuan-su-by-leetcode-solution-svxi/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
- 方法二:双指针优化
思路
如果要移除的元素恰好在数组的开头,例如序列 [1,2,3,4,5],当 val 为 1 时,我们需要把每一个元素都左移一位。注意到题目中说:「元素的顺序可以改变」。实际上我们可以直接将最后一个元素 5 移动到序列开头,取代元素 1,得到序列 [5,2,3,4],同样满足题目要求。这个优化在序列中 val 元素的数量较少时非常有效。
实现方面,我们依然使用双指针,两个指针初始时分别位于数组的首尾,向中间移动遍历该序列。
算法
如果左指针 left 指向的元素等于 val,此时将右指针 right 指向的元素复制到左指针 left 的位置,然后右指针 right 左移一位。如果复制过来的元素恰好也等于 val,可以继续把右指针 right 指向的元素的值复制过来(左指针 left 指向的等于 val 的元素的位置继续被覆盖),直到左指针指向的元素的值不等于 val 为止。
当左指针 left 和右指针 right 重合的时候,左右指针遍历完数组中所有的元素。
这样的方法两个指针在最坏的情况下合起来只遍历了数组一次。与方法一不同的是,方法二避免了需要保留的元素的重复复制操作。
作者:力扣官方题解
链接:https://leetcode.cn/problems/remove-element/solutions/730203/yi-chu-yuan-su-by-leetcode-solution-svxi/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
public class Solution
{
public int RemoveElement(int[] nums, int val)
{
int left = 0;
int right = nums.Length;
while (left < right)
{
if (nums[left] == val)
{
nums[left] = nums[right - 1];
right--;
}
else
left++;
}
return left;
}
}
2.3 优化(或者敲一遍题解?)
以下是看完思路后不看题解搓的一版,思路差不多,只不过while优先保证right处不为val,但好像其实不用专门放一个k变量?left就够了
public class Solution
{
public int RemoveElement(int[] nums, int val)
{
int left = 0;
int right = nums.Length - 1;
int k = nums.Length;
while (left <= right)
{
// 优先保证right指向的不为val
if (nums[right] == val)
{
right--;
k--;
continue;
}
// 接下来处理left
if (nums[left] == val)
{
nums[left] = nums[right];
right--;
k--;
}
left++;
}
return k;
}
}

浙公网安备 33010602011771号